package Pruziny
  connector spoj
    flow Real f(unit = "N");
    Real y(unit = "m");
    annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Ellipse(origin = {0.47, -1.17}, lineColor = {165, 0, 0}, fillColor = {26, 40, 166}, fillPattern = FillPattern.Solid, lineThickness = 0.75, extent = {{-92.74, 94.38}, {92.74, -94.38}}, endAngle = 360)}), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Ellipse(origin = {-0.47, 1.41}, fillColor = {48, 158, 18}, fillPattern = FillPattern.Solid, extent = {{-92.27, 93.21}, {92.27, -93.21}}, endAngle = 360)}));
  end spoj;

  model strop
    Pruziny.spoj spoj1 annotation(Placement(visible = true, transformation(origin = {0, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {0, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    parameter Real pozice = 0;
  equation
    spoj1.y = pozice;
    annotation(Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Rectangle(origin = {-0.71, 18.02}, lineColor = {255, 255, 255}, fillColor = {229, 146, 215}, fillPattern = FillPattern.CrossDiag, extent = {{-93.64, 75.62}, {93.64, -75.62}}), Polygon(origin = {5.61, 21.88}, fillColor = {45, 190, 19}, fillPattern = FillPattern.Solid, points = {{-16.9129, 69.64}, {-60.3758, 13.4562}, {-6.66551, -69.5827}, {60.4723, 4.97564}, {-27.5136, -4.21164}, {-16.9129, 69.64}}), Line(origin = {-8.26087, 18.6957}, points = {{-68.2609, -53.0435}, {68.2609, 53.4783}})}));
  end strop;

  model kulicka
    Pruziny.spoj spojovatko annotation(Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    parameter Real m(unit = "kg") "Hmotnost kulicky v kilogramech";
    Real y, v, a;
  equation
    der(v) = a;
    der(y) = v;
    spojovatko.f = m * a;
    y = spojovatko.y;
    annotation(Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Ellipse(origin = {0.53, -2.3}, fillColor = {255, 0, 0}, fillPattern = FillPattern.Solid, extent = {{-95.58, 94.88}, {95.58, -94.88}}, endAngle = 360)}));
  end kulicka;

  model pero
    Pruziny.spoj spoj2 annotation(Placement(visible = true, transformation(origin = {0, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {0, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Pruziny.spoj spoj1 annotation(Placement(visible = true, transformation(origin = {0, 100}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {0, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    parameter Real k "tuhost";
    Real dy "prodlouzeni pruziny";
  equation
    dy = spoj2.y - spoj1.y;
    spoj2.f = k * dy;
    spoj1.f + spoj2.f = 0;
    annotation(Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Line(origin = {-1.74871, -3.75132}, points = {{13.7628, 92.7973}, {-49.8414, 67.7089}, {43.7982, 65.2354}, {-48.0746, 35.5534}, {46.625, 36.2602}, {-45.2478, 12.5852}, {47.6851, 11.5252}, {2.10207, 9.05167}, {-37.4739, -28.0508}, {67.8265, 4.45803}, {21.8901, 20.7124}, {-67.5092, -5.78932}, {-30.4068, -37.5914}, {19.7699, -5.78932}, {-36.0605, -2.96246}, {42.7381, -19.5702}, {26.8371, 1.63118}, {-51.6082, -4.72925}, {-42.4209, -39.0049}, {28.6038, -44.6586}, {39.2045, -17.8035}, {-14.8591, -44.3052}, {-8.49864, -59.1462}, {56.1657, -60.5596}, {-25.4598, -76.4607}, {15.1763, -79.6409}, {15.5296, -93.0685}})}));
  end pero;

  model system1
    Pruziny.pero pero1(k = 2) annotation(Placement(visible = true, transformation(origin = {-40, 40}, extent = {{-17.5, -17.5}, {17.5, 17.5}}, rotation = 0)));
    Pruziny.kulicka kulicka1(m = 3) annotation(Placement(visible = true, transformation(origin = {-40, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Pruziny.strop strop1(pozice = 10) annotation(Placement(visible = true, transformation(origin = {-40, 80}, extent = {{-15, -15}, {15, 15}}, rotation = 0)));
  equation
    connect(strop1.spoj1, pero1.spoj1) annotation(Line(points = {{-40, 71}, {-40.5485, 61}, {-40, 49.1166}, {-40, 54}}, color = {165, 0, 0}));
    connect(pero1.spoj2, kulicka1.spojovatko) annotation(Line(points = {{-40, 26}, {-40.8696, 26}, {-40.8696, -0.434783}, {-40.8696, -0.434783}}, color = {165, 0, 0}));
    annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), experiment(StartTime = 0, StopTime = 20, Tolerance = 1e-6, Interval = 0.04));
  end system1;

  model sys2
    Pruziny.strop strop1(pozice = 1) annotation(Placement(visible = true, transformation(origin = {-80, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Pruziny.pero pero1(k = 2) annotation(Placement(visible = true, transformation(origin = {-60, 60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Pruziny.kulicka kulicka1(m = 1) annotation(Placement(visible = true, transformation(origin = {-80, 40}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Pruziny.pero pero2(k = 3) annotation(Placement(visible = true, transformation(origin = {-60, 20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Pruziny.kulicka kulicka2(m = 2) annotation(Placement(visible = true, transformation(origin = {-80, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  equation
    connect(kulicka2.spojovatko, pero2.spoj2) annotation(Line(points = {{-80, 0}, {-59.887, 0}, {-59.887, 11.2994}, {-59.887, 11.2994}}, color = {165, 0, 0}));
    connect(kulicka1.spojovatko, pero2.spoj1) annotation(Line(points = {{-80, 40}, {-80.226, 40}, {-80.226, 27.4011}, {-60.1695, 27.4011}, {-60.1695, 27.4011}}, color = {165, 0, 0}));
    connect(kulicka1.spojovatko, pero1.spoj2) annotation(Line(points = {{-80, 40}, {-59.6045, 40}, {-59.6045, 52}, {-60, 52}}, color = {165, 0, 0}));
    connect(strop1.spoj1, pero1.spoj1) annotation(Line(points = {{-80, 74}, {-61.0169, 74}, {-61.0169, 67.7966}, {-61.0169, 67.7966}}, color = {165, 0, 0}));
    annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), experiment(StartTime = 0, StopTime = 40, Tolerance = 1e-06, Interval = 0.08));
  end sys2;
  annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})));
end Pruziny;